/*1:*/
#line 8 "F:\Develop\mview3d\savepng.w"

#ifdef MATHGL_MAIN
#  define Global
#else
#  define Global extern
#endif

/*:1*//*3:*/
#line 33 "F:\Develop\mview3d\savepng.w"

int PNGSaveFrameBuffer(
const char*filename,
int x,int y,
int width,int height,
int interlace,
double gamma);

/*:3*//*16:*/
#line 168 "F:\Develop\mview3d\savepng.w"

int PNGSaveBitmap(
const char*filename,
int width,int height,
int oglType,
GLubyte*image,
int interlace,
double gamma);

/*:16*//*21:*/
#line 272 "F:\Develop\mview3d\savepng.w"

#define DEPTH_ENC_GRAY  (0)
#define DEPTH_ENC_CDRGB (1)
#define DEPTH_ENC_CDCMY (2)
int PNGSaveDepthBuffer(const char*filename,
int x,int y,
int width,int height,
int depthEncoding,
int interlace,
double gamma,double scale);


/*:21*//*27:*/
#line 408 "F:\Develop\mview3d\savepng.w"
int PNGSaveSIRDS(const char*filename,
int x,int y,
int width,int height,
int dpiOut,
double trueWidth,
double eyeSeparation,
double mu,int oversmpl,double scale
);

/*:27*//*29:*/
#line 459 "F:\Develop\mview3d\savepng.w"

/*31:*/
#line 471 "F:\Develop\mview3d\savepng.w"

typedef struct TextureList{
int textureID;
char*texIdentifyer;
char*texSaveName;
int texType;
int texWidth,texHeight;
GLubyte*texPixels;
GLuint texName;
struct TextureList*next;
}TextureList;

/*:31*/
#line 460 "F:\Develop\mview3d\savepng.w"

/*32:*/
#line 483 "F:\Develop\mview3d\savepng.w"

#define NotBounded (-1)
#define GrayTextureQ(t)      ((t->texType)==GL_LUMINANCE)
#define GrayAlphaTextureQ(t) ((t->texType)==GL_LUMINANCE_ALPHA)
#define RGBTextureQ(t)       ((t->texType)==GL_RGB)
#define RGBATextureQ(t)      ((t->texType)==GL_RGBA)
#define TextureID(t)    (t->textureID)
#define TextureName(t)  (t->texIdentifyer)
#define TextureFile(t)  (t->texSaveName)
#define TextureType(t)  (t->texType)
#define TextureWidth(t) (t->texWidth)
#define TextureHeight(t)(t->texHeight)
#define TextureGLName(t)    (t->texName)
#define TextureData(t)  (t->texPixels)

/*:32*/
#line 461 "F:\Develop\mview3d\savepng.w"


/*:29*//*34:*/
#line 518 "F:\Develop\mview3d\savepng.w"

Global TextureList*Textures;
Global int TextureCount;
/*:34*//*35:*/
#line 523 "F:\Develop\mview3d\savepng.w"

TextureList*CreateTexture(TextureList*lst,char*name,
int ttype,int w,int h,GLubyte*pix,long tsize,
int allowscale);

/*:35*//*40:*/
#line 610 "F:\Develop\mview3d\savepng.w"

int LengthTextureList(TextureList*lst);

/*:40*//*42:*/
#line 625 "F:\Develop\mview3d\savepng.w"

TextureList*RemoveTextureList(TextureList*lst);

/*:42*//*45:*/
#line 661 "F:\Develop\mview3d\savepng.w"

TextureList*ReadPNGTexture(TextureList*lst,char*fname,double screen_gamma,
int allowscale);

/*:45*//*54:*/
#line 842 "F:\Develop\mview3d\savepng.w"

void ReverseImageRows(int w,int h,int bpp,
GLubyte*image);
/*:54*//*56:*/
#line 867 "F:\Develop\mview3d\savepng.w"

void ClipRGBImageBorder(int w,int h,GLubyte*image,
int*wout,int*hout,GLubyte**imgout);

/*:56*//*60:*/
#line 905 "F:\Develop\mview3d\savepng.w"

int EPSSaveFrameBuffer(
const char*filename,
int x,int y,
int width,int height);

/*:60*//*62:*/
#line 957 "F:\Develop\mview3d\savepng.w"

int EPSSaveBitmap(
const char*filename,
int x,int y,
int width,int height,int channels,
GLubyte*image,double trueWidth);

/*:62*/
