#define MAX(a,b) ((a) >(b) ?(a) :(b) ) 
#define MIN(a,b) ((a) <(b) ?(a) :(b) )  \

#define CDRed(range) ((range) >0.75f||(range) <0.f? \
0.: \
(((-2.13f*(range) -1.07f) *(range) +0.133f) *(range) +0.0667f) *(range) +1.f)  \

#define CDGreen(range) ((range) <=0.5f?(1.6f*(range) +1.2f) *(range) :(3.2f*(range) -6.8f) *(range) +3.6f)  \

#define CDBlue(range) ((range) >0.5f?((-4.8f*(range) +9.2f) *(range) -3.4f) :0.0f)  \
 \

#define MAXTEXNAME 256
#define RGBBytePerPixel 3
#define RGBPixelPtr(i,j,w,img) (img+(j+w*i) *RGBBytePerPixel) 
#define PSPointPerIn (72) 
#define Separation(z) round((1.-mu*(z) ) *E/(2.-mu*(z) ) )  \

#define PutPixel(x,y,pv) *((*sirds) +(y) *(*w) +(x) ) = pv \

#define depth(i,j) DepthData_local[(j) *DepthWidth_local+(i) ] \

/*2:*/
#line 16 "F:\Develop\mview3d\savepng.w"

#undef MATHGL_MAIN
/*73:*/
#line 1130 "F:\Develop\mview3d\savepng.w"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#ifdef __WIN32__
#  include <windows.h>
#endif
#include "mathlink.h"
#include "GL/gl.h"
#include "GL/glu.h"
#include "GL/glut.h"
#include "png.h"
#include "savepng.h"
#if MACINTOSH_MATHLINK
FILE*MacCreateFile(const char*,unsigned long,unsigned long);
#endif
/*:73*/
#line 18 "F:\Develop\mview3d\savepng.w"

/*71:*/
#line 1104 "F:\Develop\mview3d\savepng.w"

static int DepthWidth_local,DepthHeight_local;
static int ImgWidth_local,ImgHeight_local;
static float*DepthData_local;

/*:71*/
#line 19 "F:\Develop\mview3d\savepng.w"

/*4:*/
#line 41 "F:\Develop\mview3d\savepng.w"

int PNGSaveFrameBuffer(
const char*filename,
int x,int y,
int width,int height,
int interlace,
double gamma)
{
FILE*fp;
int bit_depth;
GLubyte*image;
png_structp png_ptr;
png_infop info_ptr;
int i,png_color_type;
png_color_8 sig_bit;
png_bytep*row_pointers;

/*10:*/
#line 123 "F:\Develop\mview3d\savepng.w"

row_pointers= calloc(height,sizeof(png_bytep));
image= (GLubyte*)calloc(width*height*3,sizeof(GLubyte));
for(i= 0;i<height;i++)
row_pointers[i]= image+3*width*(height-1-i);
glPixelStorei(GL_PACK_ALIGNMENT,1);
glFlush();
glFinish();
glReadPixels(x,y,width,height,GL_RGB,GL_UNSIGNED_BYTE,image);

/*:10*/
#line 58 "F:\Develop\mview3d\savepng.w"

/*5:*/
#line 86 "F:\Develop\mview3d\savepng.w"

fp= fopen(filename,"wb");
if(fp==NULL){
return GL_FALSE;
}

/*:5*/
#line 59 "F:\Develop\mview3d\savepng.w"

/*6:*/
#line 98 "F:\Develop\mview3d\savepng.w"

png_ptr= png_create_write_struct(PNG_LIBPNG_VER_STRING,
(void*)NULL,NULL,NULL);
if(png_ptr==NULL)
/*14:*/
#line 162 "F:\Develop\mview3d\savepng.w"

return GL_FALSE;

/*:14*/
#line 102 "F:\Develop\mview3d\savepng.w"


/*:6*/
#line 60 "F:\Develop\mview3d\savepng.w"

/*7:*/
#line 105 "F:\Develop\mview3d\savepng.w"

info_ptr= png_create_info_struct(png_ptr);
if(info_ptr==NULL)
/*14:*/
#line 162 "F:\Develop\mview3d\savepng.w"

return GL_FALSE;

/*:14*/
#line 108 "F:\Develop\mview3d\savepng.w"


/*:7*/
#line 61 "F:\Develop\mview3d\savepng.w"

/*8:*/
#line 113 "F:\Develop\mview3d\savepng.w"

if(setjmp(png_ptr->jmpbuf))
/*14:*/
#line 162 "F:\Develop\mview3d\savepng.w"

return GL_FALSE;

/*:14*/
#line 115 "F:\Develop\mview3d\savepng.w"


/*:8*/
#line 62 "F:\Develop\mview3d\savepng.w"

/*9:*/
#line 118 "F:\Develop\mview3d\savepng.w"

png_init_io(png_ptr,fp);


/*:9*/
#line 63 "F:\Develop\mview3d\savepng.w"

bit_depth= 8*sizeof(GLubyte);
png_color_type= PNG_COLOR_TYPE_RGB;
sig_bit.red= sig_bit.green= sig_bit.blue= (unsigned char)bit_depth;
/*12:*/
#line 147 "F:\Develop\mview3d\savepng.w"

png_set_IHDR(png_ptr,info_ptr,
width,height,bit_depth,
png_color_type,
interlace?PNG_INTERLACE_ADAM7:PNG_INTERLACE_NONE,
PNG_COMPRESSION_TYPE_DEFAULT,
PNG_FILTER_TYPE_BASE);
png_set_sBIT(png_ptr,info_ptr,&sig_bit);

/*:12*/
#line 67 "F:\Develop\mview3d\savepng.w"



png_set_gAMA(png_ptr,info_ptr,gamma);

png_write_info(png_ptr,info_ptr);
/*13:*/
#line 158 "F:\Develop\mview3d\savepng.w"


png_set_packing(png_ptr);

/*:13*/
#line 73 "F:\Develop\mview3d\savepng.w"


png_write_image(png_ptr,row_pointers);
png_write_end(png_ptr,info_ptr);
/*11:*/
#line 133 "F:\Develop\mview3d\savepng.w"

if(row_pointers){
free(image);
free(row_pointers);
}


/*:11*/
#line 77 "F:\Develop\mview3d\savepng.w"


png_destroy_write_struct(&png_ptr,(png_infopp)NULL);

fclose(fp);
return GL_TRUE;
}

/*:4*/
#line 20 "F:\Develop\mview3d\savepng.w"

/*61:*/
#line 911 "F:\Develop\mview3d\savepng.w"

int EPSSaveFrameBuffer(
const char*filename,
int x,int y,
int width,int height)
{
GLubyte*image;
FILE*eps;
int i,k,mu;

image= (GLubyte*)calloc(mu= width*height*3,sizeof(GLubyte));
glPixelStorei(GL_PACK_ALIGNMENT,1);
glReadPixels(x,y,width,height,GL_RGB,GL_UNSIGNED_BYTE,image);

#if MACINTOSH_MATHLINK
eps= MacCreateFile(filename,'TEXT','gsVR');
#else
eps= fopen(filename,"w");
#endif
if(!eps){
free(image);
return GL_FALSE;
}
fprintf(eps,"%%!PS-Adobe-3.0 EPSF-3.0\n"
"%%%% Creator MathGL3d (using frame buffer)\n"
"%%%%BoundingBox: %d %d %d %d\n"
"%%EndComments\n\n",x,y,x+width,y+height);
fprintf(eps,"gsave\n");
fprintf(eps,"/picstr %d string def\n",3*width);
fprintf(eps," 0  0 translate\n %d %d scale\n",width,height);
fprintf(eps," %d %d 8\n [%d 0 0 %d 0 0]\n",width,height,width,height);
fprintf(eps,"{currentfile picstr readhexstring pop}\nfalse 3\n colorimage\n");
k= 0;
while(k<mu){
for(i= 0;i<36&&k<mu;i++)
fprintf(eps,"%02X",image[k++]);
fprintf(eps,"\n");
}
fprintf(eps,"grestore\n");
fprintf(eps,"showpage");
fclose(eps);
free(image);
return 0;
}

/*:61*/
#line 21 "F:\Develop\mview3d\savepng.w"

/*63:*/
#line 964 "F:\Develop\mview3d\savepng.w"

int EPSSaveBitmap(
const char*filename,
int x,int y,
int width,int height,int channels,
GLubyte*image,double trueWidth)
{
FILE*eps;
int i,k,mu;

mu= width*height*channels;
trueWidth*= PSPointPerIn;
#if MACINTOSH_MATHLINK
eps= MacCreateFile(filename,'TEXT','gsVR');
#else
eps= fopen(filename,"w");
#endif
if(!eps)
return GL_FALSE;
fprintf(eps,"%%!PS-Adobe-3.0 EPSF-3.0\n"
"%%%% Creator MathGL3d\n"
"%%%%BoundingBox: %lg %lg %lg %lg\n"
"%%EndComments\n\n",(double)x,(double)y,
x+trueWidth,y+height*trueWidth/width);
fprintf(eps,"gsave\n");
fprintf(eps,"/picstr %d string def\n",channels*width);
fprintf(eps," 0  0 translate\n %lg %lg scale\n",trueWidth,height*trueWidth/width);
fprintf(eps," %d %d 8\n [%d 0 0 %d 0 0]\n",width,height,width,height);
fprintf(eps,"{currentfile picstr readhexstring pop} %s\n",
3==channels?"\nfalse 3\n colorimage":" image ");
k= 0;
while(k<mu){
for(i= 0;i<36&&k<mu;i++)
fprintf(eps,"%02X",image[k++]);
fprintf(eps,"\n");
}
fprintf(eps,"grestore\n");
fprintf(eps,"showpage");
fclose(eps);
return 0;
}

/*:63*/
#line 22 "F:\Develop\mview3d\savepng.w"

/*17:*/
#line 177 "F:\Develop\mview3d\savepng.w"

int PNGSaveBitmap(
const char*filename,
int width,int height,
int oglType,
GLubyte*image,
int interlace,
double gamma)
{FILE*fp;
int bit_depth;
int byte_per_pixel;
png_structp png_ptr;
png_infop info_ptr;
int i,png_color_type;
png_color_8 sig_bit;
png_bytep*row_pointers;

/*19:*/
#line 232 "F:\Develop\mview3d\savepng.w"

switch(oglType){
case GL_LUMINANCE:
byte_per_pixel= 1;
png_color_type= PNG_COLOR_TYPE_GRAY;
break;
case GL_LUMINANCE_ALPHA:
byte_per_pixel= 2;
png_color_type= PNG_COLOR_TYPE_GRAY_ALPHA;
break;
case GL_RGB:
byte_per_pixel= 3;
png_color_type= PNG_COLOR_TYPE_RGB;
break;
case GL_RGBA:
byte_per_pixel= 4;
png_color_type= PNG_COLOR_TYPE_RGB_ALPHA;
break;
default:
return GL_FALSE;
}


/*:19*/
#line 194 "F:\Develop\mview3d\savepng.w"

/*18:*/
#line 227 "F:\Develop\mview3d\savepng.w"

row_pointers= calloc(height,sizeof(png_bytep));
for(i= 0;i<height;i++)
row_pointers[i]= image+byte_per_pixel*width*(height-1-i);

/*:18*/
#line 195 "F:\Develop\mview3d\savepng.w"

/*5:*/
#line 86 "F:\Develop\mview3d\savepng.w"

fp= fopen(filename,"wb");
if(fp==NULL){
return GL_FALSE;
}

/*:5*/
#line 196 "F:\Develop\mview3d\savepng.w"

/*6:*/
#line 98 "F:\Develop\mview3d\savepng.w"

png_ptr= png_create_write_struct(PNG_LIBPNG_VER_STRING,
(void*)NULL,NULL,NULL);
if(png_ptr==NULL)
/*14:*/
#line 162 "F:\Develop\mview3d\savepng.w"

return GL_FALSE;

/*:14*/
#line 102 "F:\Develop\mview3d\savepng.w"


/*:6*/
#line 197 "F:\Develop\mview3d\savepng.w"

/*7:*/
#line 105 "F:\Develop\mview3d\savepng.w"

info_ptr= png_create_info_struct(png_ptr);
if(info_ptr==NULL)
/*14:*/
#line 162 "F:\Develop\mview3d\savepng.w"

return GL_FALSE;

/*:14*/
#line 108 "F:\Develop\mview3d\savepng.w"


/*:7*/
#line 198 "F:\Develop\mview3d\savepng.w"

/*8:*/
#line 113 "F:\Develop\mview3d\savepng.w"

if(setjmp(png_ptr->jmpbuf))
/*14:*/
#line 162 "F:\Develop\mview3d\savepng.w"

return GL_FALSE;

/*:14*/
#line 115 "F:\Develop\mview3d\savepng.w"


/*:8*/
#line 199 "F:\Develop\mview3d\savepng.w"

/*9:*/
#line 118 "F:\Develop\mview3d\savepng.w"

png_init_io(png_ptr,fp);


/*:9*/
#line 200 "F:\Develop\mview3d\savepng.w"

bit_depth= 8*sizeof(GLubyte);
if(oglType==GL_RGB||oglType==GL_RGBA)
sig_bit.red= sig_bit.green= sig_bit.blue= (unsigned char)bit_depth;
else
sig_bit.gray= (unsigned char)bit_depth;
if(oglType==GL_LUMINANCE_ALPHA||oglType==GL_RGBA)
sig_bit.alpha= (unsigned char)bit_depth;

/*12:*/
#line 147 "F:\Develop\mview3d\savepng.w"

png_set_IHDR(png_ptr,info_ptr,
width,height,bit_depth,
png_color_type,
interlace?PNG_INTERLACE_ADAM7:PNG_INTERLACE_NONE,
PNG_COMPRESSION_TYPE_DEFAULT,
PNG_FILTER_TYPE_BASE);
png_set_sBIT(png_ptr,info_ptr,&sig_bit);

/*:12*/
#line 209 "F:\Develop\mview3d\savepng.w"



png_set_gAMA(png_ptr,info_ptr,gamma);

png_write_info(png_ptr,info_ptr);
/*13:*/
#line 158 "F:\Develop\mview3d\savepng.w"


png_set_packing(png_ptr);

/*:13*/
#line 215 "F:\Develop\mview3d\savepng.w"


png_write_image(png_ptr,row_pointers);
png_write_end(png_ptr,info_ptr);
free(row_pointers);

png_destroy_write_struct(&png_ptr,(png_infopp)NULL);

fclose(fp);
return GL_TRUE;
}

/*:17*/
#line 23 "F:\Develop\mview3d\savepng.w"

/*22:*/
#line 290 "F:\Develop\mview3d\savepng.w"

int PNGSaveDepthBuffer(const char*filename,
int x,int y,
int width,int height,
int depthEncoding,
int interlace,
double gamma,double scale)
{GLubyte*bimage,*bptr;
GLfloat*dbuff,c;
GLfloat oned,fmin,dmax,dmin;
int oglType,i;
long int size;
int res;

size= width*height;
oglType= (depthEncoding>0?GL_RGB:GL_LUMINANCE);
bimage= (GLubyte*)calloc((depthEncoding?3:1)*size,sizeof(GLubyte));

/*23:*/
#line 318 "F:\Develop\mview3d\savepng.w"

dbuff= (GLfloat*)calloc(size,sizeof(GLfloat));
glPixelStorei(GL_PACK_ALIGNMENT,1);
glReadPixels(x,y,width,height,GL_DEPTH_COMPONENT,GL_FLOAT,dbuff);


/*:23*/
#line 308 "F:\Develop\mview3d\savepng.w"

/*24:*/
#line 326 "F:\Develop\mview3d\savepng.w"

{GLint i,j;
GLint viewport[4];
GLdouble mvmatrix[16],projmatrix[16];
GLdouble x,y,z,wx,wy,wz;
GLdouble vpx,vpy,vpz;

glGetIntegerv(GL_VIEWPORT,viewport);
glGetDoublev(GL_MODELVIEW_MATRIX,mvmatrix);
glGetDoublev(GL_PROJECTION_MATRIX,projmatrix);
gluUnProject(0.5*width,0.5*height,0.,
mvmatrix,projmatrix,viewport,
&vpx,&vpy,&vpz);
for(i= 0;i<width;i++){
x= (GLdouble)i;
for(j= 0;j<height;j++){
y= (GLdouble)j;
z= dbuff[width*j+i];
gluUnProject(x,y,z,mvmatrix,projmatrix,viewport,&wx,&wy,&wz);
wx-= vpx;wy-= vpy;wz-= vpz;
z= sqrt(wx*wx+wy*wy+wz*wz);
dbuff[width*j+i]= z;
}
}
}

/*:24*/
#line 309 "F:\Develop\mview3d\savepng.w"

/*25:*/
#line 352 "F:\Develop\mview3d\savepng.w"

dmin= dmax= 0.0f;
for(i= 0;i<size;i++)
if(dbuff[i]>dmax)dmax= dbuff[i];
else if(dbuff[i]<dmin)dmin= dbuff[i];
dmin= dmax;
for(i= 0;i<size;i++)
if(dbuff[i]>0.0&&dbuff[i]<dmin)dmin= dbuff[i];
if(dmax!=dmin){
oned= 1.f/(dmax-dmin);
for(i= 0;i<size;i++){
dbuff[i]= scale*(dbuff[i]-dmin)*oned;
if(dbuff[i]>1.0)dbuff[i]= 1.0;
}
}

/*:25*/
#line 310 "F:\Develop\mview3d\savepng.w"

/*26:*/
#line 368 "F:\Develop\mview3d\savepng.w"

bptr= bimage;
switch(depthEncoding){
case DEPTH_ENC_GRAY:
for(i= 0;i<size;i++)
*(bptr++)= (GLubyte)(255.f*dbuff[i]);
break;
case DEPTH_ENC_CDRGB:
for(i= 0;i<size;i++){
c= CDRed(dbuff[i]);
c= MAX(MIN(c,1.f),0.f);
*(bptr++)= (GLubyte)(255.f*c);
c= CDGreen(dbuff[i]);
c= MAX(MIN(c,1.f),0.f);
*(bptr++)= (GLubyte)(255.f*c);
c= CDBlue(dbuff[i]);
c= MAX(MIN(c,1.f),0.f);
*(bptr++)= (GLubyte)(255.f*c);
}
break;
default:
for(i= 0;i<size;i++){
c= CDRed(dbuff[i]);
c= 1.f-MAX(MIN(c,1.f),0.f);
*(bptr++)= (GLubyte)(255.f*c);
c= CDGreen(dbuff[i]);
c= 1.f-MAX(MIN(c,1.f),0.f);
*(bptr++)= (GLubyte)(255.f*c);
c= CDBlue(dbuff[i]);
c= 1.f-MAX(MIN(c,1.f),0.f);
*(bptr++)= (GLubyte)(255.f*c);
}
break;
}

/*:26*/
#line 311 "F:\Develop\mview3d\savepng.w"

res= PNGSaveBitmap(filename,width,height,oglType,bimage,interlace,gamma);
free(bimage);
free(dbuff);
return res;
}

/*:22*/
#line 24 "F:\Develop\mview3d\savepng.w"

/*72:*/
#line 1111 "F:\Develop\mview3d\savepng.w"

static float Depth(register int i,register int j)
{register float x,y;
float d,d1;

x= (float)i/((float)(ImgWidth_local));
y= (float)j/((float)(ImgHeight_local));
i= x= DepthWidth_local*x;
j= y= DepthHeight_local*y;
if(i>(DepthWidth_local-2))i= DepthWidth_local-2;
if(j>(DepthHeight_local-2))j= DepthHeight_local-2;
x-= (float)i;
y-= (float)j;
d= (1.0f-x)*depth(i,j)+x*depth(i+1,j);
d1= (1.0f-x)*depth(i,j+1)+x*depth(i+1,j+1);
return(1.0f-y)*d+y*d1;
}

/*:72*/
#line 25 "F:\Develop\mview3d\savepng.w"

/*65:*/
#line 1019 "F:\Develop\mview3d\savepng.w"

#if !MACINTOSH_MATHLINK
#  define round(x) ((int)((x)+0.5))
#endif
void CreateStereogram(
unsigned char**sirds,int*w,int*h,
float*z,int width,int height,
int dotPerIn,double widthIn,
double eyeSeparation,
double mu,int oversample
)
{double E,zt,d;
int*same,*pix;
int x,y;
int left,right;
int s;
int visible,t,l;
int rowSize;


/*69:*/
#line 1085 "F:\Develop\mview3d\savepng.w"

E= eyeSeparation*dotPerIn;
ImgWidth_local= *w= dotPerIn*widthIn;
ImgHeight_local= *h= (*w)*(width/height);
rowSize= *w*oversample;
ImgWidth_local*= oversample;
*sirds= (unsigned char*)calloc((*w)*(*h),sizeof(unsigned char));
same= (int*)calloc(rowSize,sizeof(int));
pix= (int*)calloc(rowSize,sizeof(int));

DepthData_local= z;
DepthWidth_local= width;
DepthHeight_local= height;

/*:69*/
#line 1039 "F:\Develop\mview3d\savepng.w"

for(y= 0;y<(*h);y++){
for(x= 0;x<rowSize;x++)
same[x]= x;
/*66:*/
#line 1050 "F:\Develop\mview3d\savepng.w"

for(x= 0;x<rowSize;x++){
d= Depth(x,y);
s= Separation(d);
left= x-(s/2);
right= left+s;
if(0<=left&&right<rowSize){
/*67:*/
#line 1062 "F:\Develop\mview3d\savepng.w"

{int k;
for(k= same[left];k!=left&&k!=right;k= same[left])
if(k<right)
left= k;
else{
left= right;
right= k;
}
same[left]= right;
}

/*:67*/
#line 1057 "F:\Develop\mview3d\savepng.w"

}
}


/*:66*/
#line 1043 "F:\Develop\mview3d\savepng.w"

/*68:*/
#line 1074 "F:\Develop\mview3d\savepng.w"

for(x= rowSize-1;x>-1;x--)
pix[x]= (same[x]==x?255*(rand()&1):pix[same[x]]);
for(x= 0;x<rowSize;x+= oversample){
int k,pval;
for(pval= 0,k= x;k<x+oversample;k++)
pval+= pix[k];
pval/= oversample;
PutPixel(x/oversample,y,pval);
}

/*:68*/
#line 1044 "F:\Develop\mview3d\savepng.w"

}
/*70:*/
#line 1099 "F:\Develop\mview3d\savepng.w"

DepthData_local= NULL;
free(pix);
free(same);

/*:70*/
#line 1046 "F:\Develop\mview3d\savepng.w"

}


/*:65*/
#line 26 "F:\Develop\mview3d\savepng.w"

/*28:*/
#line 417 "F:\Develop\mview3d\savepng.w"

int PNGSaveSIRDS(const char*filename,
int x,int y,
int width,int height,
int dpiOut,
double trueWidth,
double eyeSeparation,
double mu,int oversmpl,double scale
)
{GLubyte*bimage,*bptr;
GLfloat*dbuff;
GLfloat oned,fmin,dmax,dmin;
int oglType,i;
long int size;
int iw,ih;
int res;

size= width*height;

/*23:*/
#line 318 "F:\Develop\mview3d\savepng.w"

dbuff= (GLfloat*)calloc(size,sizeof(GLfloat));
glPixelStorei(GL_PACK_ALIGNMENT,1);
glReadPixels(x,y,width,height,GL_DEPTH_COMPONENT,GL_FLOAT,dbuff);


/*:23*/
#line 436 "F:\Develop\mview3d\savepng.w"

/*24:*/
#line 326 "F:\Develop\mview3d\savepng.w"

{GLint i,j;
GLint viewport[4];
GLdouble mvmatrix[16],projmatrix[16];
GLdouble x,y,z,wx,wy,wz;
GLdouble vpx,vpy,vpz;

glGetIntegerv(GL_VIEWPORT,viewport);
glGetDoublev(GL_MODELVIEW_MATRIX,mvmatrix);
glGetDoublev(GL_PROJECTION_MATRIX,projmatrix);
gluUnProject(0.5*width,0.5*height,0.,
mvmatrix,projmatrix,viewport,
&vpx,&vpy,&vpz);
for(i= 0;i<width;i++){
x= (GLdouble)i;
for(j= 0;j<height;j++){
y= (GLdouble)j;
z= dbuff[width*j+i];
gluUnProject(x,y,z,mvmatrix,projmatrix,viewport,&wx,&wy,&wz);
wx-= vpx;wy-= vpy;wz-= vpz;
z= sqrt(wx*wx+wy*wy+wz*wz);
dbuff[width*j+i]= z;
}
}
}

/*:24*/
#line 437 "F:\Develop\mview3d\savepng.w"

/*25:*/
#line 352 "F:\Develop\mview3d\savepng.w"

dmin= dmax= 0.0f;
for(i= 0;i<size;i++)
if(dbuff[i]>dmax)dmax= dbuff[i];
else if(dbuff[i]<dmin)dmin= dbuff[i];
dmin= dmax;
for(i= 0;i<size;i++)
if(dbuff[i]>0.0&&dbuff[i]<dmin)dmin= dbuff[i];
if(dmax!=dmin){
oned= 1.f/(dmax-dmin);
for(i= 0;i<size;i++){
dbuff[i]= scale*(dbuff[i]-dmin)*oned;
if(dbuff[i]>1.0)dbuff[i]= 1.0;
}
}

/*:25*/
#line 438 "F:\Develop\mview3d\savepng.w"

for(i= 0;i<size;i++)
dbuff[i]= 1.0-dbuff[i];
CreateStereogram(
&bimage,&iw,&ih,
dbuff,width,height,
dpiOut,
trueWidth,
eyeSeparation,
mu,oversmpl);
oglType= GL_LUMINANCE;
res= PNGSaveBitmap(filename,iw,ih,oglType,bimage,GL_FALSE,1.0);

free(bimage);
free(dbuff);
return res;
}


/*:28*/
#line 27 "F:\Develop\mview3d\savepng.w"

/*50:*/
#line 781 "F:\Develop\mview3d\savepng.w"

/*51:*/
#line 788 "F:\Develop\mview3d\savepng.w"

int SameRGBColorQ(GLubyte*clipc,int i,int j,int w,GLubyte*img)
{GLubyte*pos;

pos= RGBPixelPtr(i,j,w,img);
return(*pos==*clipc&&pos[1]==clipc[1]&&pos[2]==clipc[2]);
}

/*:51*/
#line 782 "F:\Develop\mview3d\savepng.w"

/*52:*/
#line 796 "F:\Develop\mview3d\savepng.w"

int SameRGBRowQ(GLubyte*clipc,int i,int w,GLubyte*img)
{int j;
int isSame;

isSame= SameRGBColorQ(clipc,i,0,w,img);
j= 1;
while(isSame&&j<w){
isSame= isSame&&SameRGBColorQ(clipc,i,j,w,img);
j++;
}
return isSame;
}

/*:52*/
#line 783 "F:\Develop\mview3d\savepng.w"

/*53:*/
#line 810 "F:\Develop\mview3d\savepng.w"

void TransposeImage(int*w,int*h,GLubyte*img)
{GLubyte**row,**tRow,*tImage;
int i,j;

tImage= calloc((*w)*(*h)*RGBBytePerPixel,sizeof(GLubyte));
row= calloc(*h,sizeof(GLubyte*));
tRow= calloc(*w,sizeof(GLubyte*));
for(i= 0;i<*h;i++){
row[i]= RGBPixelPtr(i,0,*w,img);
}
for(j= 0;j<*w;j++){
tRow[j]= RGBPixelPtr(j,0,*h,tImage);
}
for(i= 0;i<*h;i++)
for(j= 0;j<*w;j++){
memcpy(tRow[j]+RGBBytePerPixel*i,
row[i]+RGBBytePerPixel*j,
RGBBytePerPixel*sizeof(GLubyte));
}
memcpy(img,tImage,(*w)*(*h)*RGBBytePerPixel);
i= *h;
*h= *w;
*w= i;
free(tRow);
free(row);
free(tImage);
}


/*:53*/
#line 784 "F:\Develop\mview3d\savepng.w"

/*55:*/
#line 845 "F:\Develop\mview3d\savepng.w"

void ReverseImageRows(int w,int h,int bpp,
GLubyte*image)
{GLubyte*tmpRow;
int rowSize;
int i,n2;

tmpRow= (GLubyte*)calloc(rowSize= w*bpp,sizeof(GLubyte));
n2= h/2;
for(i= 0;i<n2;i++){
memmove(tmpRow,image+i*rowSize,rowSize*sizeof(GLubyte));
memmove(image+i*rowSize,image+(h-1-i)*rowSize,rowSize*sizeof(GLubyte));
memmove(image+(h-1-i)*rowSize,tmpRow,rowSize*sizeof(GLubyte));
}
free(tmpRow);
}

/*:55*/
#line 785 "F:\Develop\mview3d\savepng.w"

/*57:*/
#line 871 "F:\Develop\mview3d\savepng.w"

void ClipRGBImageBorder(int w,int h,GLubyte*image,
int*wout,int*hout,GLubyte**imgout)
{GLubyte clipColor[RGBBytePerPixel];
int i;

*wout= w;
*hout= h;
*imgout= image;
clipColor[0]= image[0];clipColor[1]= image[1];clipColor[2]= image[2];
/*58:*/
#line 889 "F:\Develop\mview3d\savepng.w"

i= *hout-1;
while(i>=0&&SameRGBRowQ(clipColor,i,*wout,*imgout)){
(*hout)--;
i--;
}

/*:58*/
#line 881 "F:\Develop\mview3d\savepng.w"

/*59:*/
#line 896 "F:\Develop\mview3d\savepng.w"

while((*hout)>=0&&SameRGBRowQ(clipColor,0,*wout,*imgout)){
(*hout)--;
*imgout+= RGBBytePerPixel*(*wout);
}

/*:59*/
#line 882 "F:\Develop\mview3d\savepng.w"

TransposeImage(wout,hout,*imgout);
/*58:*/
#line 889 "F:\Develop\mview3d\savepng.w"

i= *hout-1;
while(i>=0&&SameRGBRowQ(clipColor,i,*wout,*imgout)){
(*hout)--;
i--;
}

/*:58*/
#line 884 "F:\Develop\mview3d\savepng.w"

/*59:*/
#line 896 "F:\Develop\mview3d\savepng.w"

while((*hout)>=0&&SameRGBRowQ(clipColor,0,*wout,*imgout)){
(*hout)--;
*imgout+= RGBBytePerPixel*(*wout);
}

/*:59*/
#line 885 "F:\Develop\mview3d\savepng.w"

TransposeImage(wout,hout,*imgout);
}

/*:57*/
#line 786 "F:\Develop\mview3d\savepng.w"


/*:50*/
#line 28 "F:\Develop\mview3d\savepng.w"

/*30:*/
#line 463 "F:\Develop\mview3d\savepng.w"

/*33:*/
#line 502 "F:\Develop\mview3d\savepng.w"

int PowerOf2Q(int i,int*lower)
{int p= 1;

*lower= i;
while(p<=i&&p<INT_MAX){
if((p&i)==i)return GL_TRUE;
p<<= 1;
}
*lower= p>>1;
return GL_FALSE;
}

/*:33*/
#line 464 "F:\Develop\mview3d\savepng.w"

/*36:*/
#line 529 "F:\Develop\mview3d\savepng.w"

TextureList*CreateTexture(TextureList*lst,char*name,
int ttype,int w,int h,GLubyte*pix,long tsize,
int allowscale)
{long psize,lsize;
int w1,h1,validWidth,validHeight;
TextureList*head;

head= (TextureList*)malloc(sizeof(TextureList));
if(!head)return NULL;
head->next= lst;
TextureGLName(head)= -1;
TextureType(head)= ttype;
TextureName(head)= (char*)calloc(MAXTEXNAME,sizeof(char));
TextureFile(head)= (char*)calloc(MAXTEXNAME,sizeof(char));
strcpy(TextureFile(head),"");
TextureID(head)= TextureCount;
if(!*name||(0==strcmp(name,"Automatic")))
sprintf(TextureName(head),"MVTexture2D[%d]",TextureCount++);
else
strcpy(TextureName(head),name);
/*37:*/
#line 556 "F:\Develop\mview3d\savepng.w"

switch(ttype){
case GL_LUMINANCE:
psize= 1;
break;
case GL_LUMINANCE_ALPHA:
psize= 2;
break;
case GL_RGB:
psize= 3;
break;
case GL_RGBA:
psize= 4;
break;
default:
psize= 0;
}

/*:37*/
#line 550 "F:\Develop\mview3d\savepng.w"

/*38:*/
#line 581 "F:\Develop\mview3d\savepng.w"

validWidth= PowerOf2Q(w,&w1);
validHeight= PowerOf2Q(h,&h1);
if(!(validWidth&&validHeight)){
int res;
if(!allowscale)/*39:*/
#line 602 "F:\Develop\mview3d\savepng.w"

{
free(TextureName(head));
free(head);
return NULL;
}

/*:39*/
#line 586 "F:\Develop\mview3d\savepng.w"

lsize= (TextureWidth(head)= w1)*(TextureHeight(head)= h1)*(psize+4);
TextureData(head)= (GLubyte*)calloc(lsize,sizeof(GLubyte));
if(!TextureData(head))/*39:*/
#line 602 "F:\Develop\mview3d\savepng.w"

{
free(TextureName(head));
free(head);
return NULL;
}

/*:39*/
#line 589 "F:\Develop\mview3d\savepng.w"

glPixelStorei(GL_UNPACK_ALIGNMENT,1);
res= gluScaleImage(ttype,w,h,GL_UNSIGNED_BYTE,pix,
w1,h1,GL_UNSIGNED_BYTE,TextureData(head));
if(res)/*39:*/
#line 602 "F:\Develop\mview3d\savepng.w"

{
free(TextureName(head));
free(head);
return NULL;
}

/*:39*/
#line 593 "F:\Develop\mview3d\savepng.w"

}
else{
lsize= (TextureWidth(head)= w)*(TextureHeight(head)= h)*psize;
TextureData(head)= (GLubyte*)calloc(lsize,sizeof(GLubyte));
if(!TextureData(head))/*39:*/
#line 602 "F:\Develop\mview3d\savepng.w"

{
free(TextureName(head));
free(head);
return NULL;
}

/*:39*/
#line 598 "F:\Develop\mview3d\savepng.w"

memcpy(TextureData(head),pix,lsize*sizeof(GLubyte));
}

/*:38*/
#line 551 "F:\Develop\mview3d\savepng.w"

return head;
}


/*:36*/
#line 465 "F:\Develop\mview3d\savepng.w"

/*41:*/
#line 613 "F:\Develop\mview3d\savepng.w"

int LengthTextureList(TextureList*lst)
{int len= 0;

while(lst){
lst= lst->next;
len++;
}
return len;
}

/*:41*/
#line 466 "F:\Develop\mview3d\savepng.w"

/*43:*/
#line 628 "F:\Develop\mview3d\savepng.w"

TextureList*RemoveTextureList(TextureList*lst)
{TextureList*tail;
GLuint*texNames;
int len,i;

if(!lst)return NULL;
/*44:*/
#line 647 "F:\Develop\mview3d\savepng.w"

tail= lst;
len= LengthTextureList(tail);
texNames= (GLuint*)calloc(len,sizeof(GLuint));
i= 0;
while(tail){
if(glIsTexture(TextureGLName(tail)))
texNames[i++]= TextureGLName(tail);
tail= tail->next;
}
if(i)glDeleteTextures(i,texNames);
free(texNames);

/*:44*/
#line 635 "F:\Develop\mview3d\savepng.w"

while(lst){
tail= lst->next;
free(TextureData(lst));
free(TextureName(lst));
free(TextureFile(lst));
free(lst);
lst= tail;
}
return NULL;
}

/*:43*/
#line 467 "F:\Develop\mview3d\savepng.w"

/*46:*/
#line 665 "F:\Develop\mview3d\savepng.w"

TextureList*ReadPNGTexture(TextureList*lst,char*fname,double screen_gamma,
int allowscale)
{
double image_gamma;
png_structp png_ptr= NULL;
png_infop info_ptr= NULL;
png_uint_32 width,height,row_size;
int bit_depth,color_type,interlace_type;
png_bytep*row_pointers,trans= NULL;
png_byte*image;
int num_trans= -1;
png_color_16*trans_values= NULL;
FILE*fp;
TextureList*head;

if((fp= fopen(fname,"rb"))==NULL)
/*14:*/
#line 162 "F:\Develop\mview3d\savepng.w"

return GL_FALSE;

/*:14*/
#line 682 "F:\Develop\mview3d\savepng.w"

/*47:*/
#line 738 "F:\Develop\mview3d\savepng.w"

png_ptr= png_create_read_struct(PNG_LIBPNG_VER_STRING,
(void*)NULL,NULL,NULL);
if(png_ptr==NULL)
/*14:*/
#line 162 "F:\Develop\mview3d\savepng.w"

return GL_FALSE;

/*:14*/
#line 742 "F:\Develop\mview3d\savepng.w"


/*:47*/
#line 683 "F:\Develop\mview3d\savepng.w"

/*7:*/
#line 105 "F:\Develop\mview3d\savepng.w"

info_ptr= png_create_info_struct(png_ptr);
if(info_ptr==NULL)
/*14:*/
#line 162 "F:\Develop\mview3d\savepng.w"

return GL_FALSE;

/*:14*/
#line 108 "F:\Develop\mview3d\savepng.w"


/*:7*/
#line 684 "F:\Develop\mview3d\savepng.w"

/*8:*/
#line 113 "F:\Develop\mview3d\savepng.w"

if(setjmp(png_ptr->jmpbuf))
/*14:*/
#line 162 "F:\Develop\mview3d\savepng.w"

return GL_FALSE;

/*:14*/
#line 115 "F:\Develop\mview3d\savepng.w"


/*:8*/
#line 685 "F:\Develop\mview3d\savepng.w"

/*9:*/
#line 118 "F:\Develop\mview3d\savepng.w"

png_init_io(png_ptr,fp);


/*:9*/
#line 686 "F:\Develop\mview3d\savepng.w"



png_read_info(png_ptr,info_ptr);

png_get_IHDR(png_ptr,info_ptr,&width,&height,&bit_depth,&color_type,
&interlace_type,NULL,NULL);
png_get_tRNS(png_ptr,info_ptr,&trans,&num_trans,&trans_values);

png_set_strip_16(png_ptr);


if(color_type==PNG_COLOR_TYPE_PALETTE||bit_depth<8)
png_set_expand(png_ptr);



if(png_get_valid(png_ptr,info_ptr,PNG_INFO_tRNS))
png_set_expand(png_ptr);





if(png_get_gAMA(png_ptr,info_ptr,&image_gamma))
png_set_gamma(png_ptr,screen_gamma,image_gamma);




png_read_update_info(png_ptr,info_ptr);
/*49:*/
#line 767 "F:\Develop\mview3d\savepng.w"

{unsigned int i;

row_pointers= calloc(height,sizeof(png_bytep));
row_size= png_get_rowbytes(png_ptr,info_ptr);
image= (GLubyte*)calloc(height,row_size);
for(i= 0;i<height;i++)
row_pointers[i]= image+row_size*(height-1-i);
}


/*:49*/
#line 717 "F:\Develop\mview3d\savepng.w"

png_read_image(png_ptr,row_pointers);

/*48:*/
#line 744 "F:\Develop\mview3d\savepng.w"

{int oglType;

switch(color_type){
case PNG_COLOR_TYPE_GRAY:
oglType= GL_LUMINANCE;
break;
case PNG_COLOR_TYPE_GRAY_ALPHA:
oglType= GL_LUMINANCE_ALPHA;
break;
case PNG_COLOR_TYPE_PALETTE:
case PNG_COLOR_TYPE_RGB:
oglType= GL_RGB;
break;
case PNG_COLOR_TYPE_RGB_ALPHA:
oglType= GL_RGBA;
break;
}
head= CreateTexture(lst,"",oglType,width,height,image,height*row_size,allowscale);
if(head)
lst= head;
}

/*:48*/
#line 720 "F:\Develop\mview3d\savepng.w"


png_read_end(png_ptr,info_ptr);


png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
/*11:*/
#line 133 "F:\Develop\mview3d\savepng.w"

if(row_pointers){
free(image);
free(row_pointers);
}


/*:11*/
#line 726 "F:\Develop\mview3d\savepng.w"


fclose(fp);
return lst;
}

/*:46*/
#line 468 "F:\Develop\mview3d\savepng.w"



/*:30*/
#line 29 "F:\Develop\mview3d\savepng.w"


/*:2*/
